function Prediction=BoundaryInitialConditionInterpolator(z,t,eta,BoundaryNodeCoordinates,tlist,BoundaryNodeValues,MeshPoints,InitialFunctionVal)
%checked 4
if(tlist(1)~=0)
    display('error')
    return
end
m1=size(z,1);
m2=length(t);
m=m1*m2;

scaledgrid=[MeshPoints sqrt(eta)*zeros(size(MeshPoints,1),1)];
scaledgrid=[scaledgrid; repmat(BoundaryNodeCoordinates,size(tlist,1)-1,1) sqrt(eta)*kron(tlist(2:end),ones(size(BoundaryNodeCoordinates,1),1))];
Ygrid=[InitialFunctionVal; repmat(BoundaryNodeValues,size(tlist,1)-1,1)];
s=[repmat(z,m2,1) kron(t,ones(m1,1))];
dist2=(pdist2(scaledgrid,[s(:,1:(end-1)) sqrt(eta)*s(:,end)])).^2;

Prediction=zeros(m,1);
for i=1:m
    Identify=dist2(:,i)<10^-32;
    if(sum(Identify)==1)
        Prediction(i)=Ygrid(Identify);        
    elseif(sum(Identify)>1)
        Prediction(i)=mean(Ygrid(Identify));
    else
        Prediction(i)=sum(Ygrid./dist2(:,i))/sum(1./dist2(:,i));
    end
end
