function ExampleBICInterpolatorSimulation2
global DesignUncoded MeshPoints tlist Data designsize nmesh ntlist N
%Example 1
%checked 4
tlist = linspace(0,3600,11)';
ntlist=length(tlist);
d=8;
%b1,b2,initial,thick,hCoeff,ta,k,r
Max=[70 70 20 0.0025 10 270 370 3.3*10^6];
Min=[700 700 40 0.005 60 330 430 3.5*10^6];
Range=Max-Min;

ntest=50;
xtest=lhsdesign(ntest,d,'criterion','maximin');
xtestuncoded=xtest.*repmat(Range,ntest,1)+repmat(Min,ntest,1);

[u, MeshPoints, e, t]=computetemperature(xtestuncoded(1,:));

N=length(u(:));
MeshPoints=MeshPoints';
nmesh=size(MeshPoints,1);

ytest=zeros(ntest,N);
for i=1:ntest
    u=computetemperature(xtestuncoded(i,:));
    ytest(i,:)=u(:)';
end

CorrelNo=1;
designsize=7*d;
nosim=1;
options=optimoptions(@fminunc,'MaxIter',10^3,'MaxFunEvals',10^5,'TolFun',10^-2,'TolX',10^-2,'Display','off','Algorithm','quasi-newton');

MSE=zeros(nosim,1);
MAE=zeros(nosim,1);
coverage=zeros(nosim,1);
avepredintlength=zeros(nosim,1);
time=zeros(nosim,1);

MSE2=zeros(nosim,1);
MAE2=zeros(nosim,1);
coverage2=zeros(nosim,1);
avepredintlength2=zeros(nosim,1);
time2=zeros(nosim,1);

for run=1:nosim
Design=lhsdesign(designsize,d,'criterion','maximin');
DesignUncoded=Design.*repmat(Range,designsize,1)+repmat(Min,designsize,1);

Data=zeros(designsize,N);
for i=1:designsize
    [solution]=computetemperature(DesignUncoded(i,:));
    Data(i,:)=solution(:)';
end

tic
%[optlogpar, fval, exitflag] = fminunc(@OptimizeParameters,[2/(max(tlist))^2 2*tlist(2)^2 2*370^2],options)
[optlogpar, fval, exitflag] = fminunc(@OptimizeParameters,[0 0 0],options)

opteta=exp(optlogpar(1));
optweights=exp(optlogpar(2:3));

Q=zeros(designsize,N);
for i=1:designsize
    InitialFunctionVal=u0func(MeshPoints,DesignUncoded(i,3));
    x=DesignUncoded(i,7);
    x0=[Inf];
    profile=computeprofile(DesignUncoded(i,1),DesignUncoded(i,2),DesignUncoded(i,5),DesignUncoded(i,6),MeshPoints);
    Yhat=InitialConditionAnalyticalApproxInterpolator(MeshPoints,tlist,opteta,tlist,MeshPoints,InitialFunctionVal,x,x0,optweights,profile);    
    Q(i,:)=Yhat';    
end

transformeddata=Data-Q;

[EigVec,EigVal,zeta,MY]=functionalPCA(transformeddata);

J=find((cumsum(EigVal)/sum(EigVal))>0.999,1,'first');
EL=EigVec(:,1:J)*diag(sqrt(EigVal(1:J)));

zetapred=zeros(J,ntest);
zetaPosCov=cell(1,J);
for i=1:J
    [zetapred(i,:),zetaPosCov{i}]=GPFitPredict(Design,zeta(:,i),CorrelNo,xtest,2);
end
posmean=EL*zetapred;

poscov=cell(1,ntest);
for i=1:ntest
    C=zeros(J,J);
    for j=1:J
        C(j,j)=zetaPosCov{j}(i,i);
    end
    poscov{i}=EL*C*EL';
end
PredictTest=posmean;

PItest=zeros(N,ntest);
for i=1:ntest
    InitialFunctionVal=u0func(MeshPoints,xtestuncoded(i,3));
    x=xtestuncoded(i,7);
    x0=[Inf];
    profile=computeprofile(xtestuncoded(i,1),xtestuncoded(i,2),xtestuncoded(i,5),xtestuncoded(i,6),MeshPoints);
    PItest(:,i)=InitialConditionAnalyticalApproxInterpolator(MeshPoints,tlist,opteta,tlist,MeshPoints,InitialFunctionVal,x,x0,optweights,profile);
end
PredictTest=PredictTest+PItest+repmat(MY,1,ntest);

UCL=zeros(N,ntest);
LCL=zeros(N,ntest);
for i=1:ntest
    UCL(:,i)=PredictTest(:,i)+norminv(0.99)*sqrt(diag(poscov{i}));
    LCL(:,i)=PredictTest(:,i)-norminv(0.99)*sqrt(diag(poscov{i}));    
end
toc

AbsErr=abs(PredictTest'-ytest);
MAE(run)=mean(mean(AbsErr));
MSE(run)=mean(mean(AbsErr.^2));
coverage(run)=mean(mean(((LCL')<=ytest).*(ytest<=(UCL'))));
avepredintlength(run)=mean(mean(UCL-LCL));
time(run)=toc;


tic

[EigVec,EigVal,zeta,MY]=functionalPCA(Data);

J=find((cumsum(EigVal)/sum(EigVal))>0.999,1,'first');
EL=EigVec(:,1:J)*diag(sqrt(EigVal(1:J)));

zetapred=zeros(J,ntest);
zetaPosCov=cell(1,J);
for i=1:J
    [zetapred(i,:),zetaPosCov{i}]=GPFitPredict(Design,zeta(:,i),CorrelNo,xtest,2);
end
posmean=EL*zetapred;

poscov=cell(1,ntest);
for i=1:ntest
    C=zeros(J,J);
    for j=1:J
        C(j,j)=zetaPosCov{j}(i,i);
    end
    poscov{i}=EL*C*EL';
end
PredictTest2=posmean+repmat(MY,1,ntest);

UCL2=zeros(N,ntest);
LCL2=zeros(N,ntest);
for i=1:ntest
    UCL2(:,i)=PredictTest2(:,i)+norminv(0.99)*sqrt(diag(poscov{i}));
    LCL2(:,i)=PredictTest2(:,i)-norminv(0.99)*sqrt(diag(poscov{i}));    
end

toc
AbsErr2=abs(PredictTest2'-ytest);
MAE2(run)=mean(mean(AbsErr2));
MSE2(run)=mean(mean(AbsErr2.^2));
coverage2(run)=mean(mean(((LCL2')<=ytest).*(ytest<=(UCL2'))));
avepredintlength2(run)=mean(mean(UCL2-LCL2));
time2(run)=toc;

%mean(mean(((LCL'-0)<=ytest).*(ytest<=(UCL'+0))))
%mean(mean(((LCL'-10^-12)<=ytest).*(ytest<=(UCL'+10^-12))))
%coverage(run)
%coverage2(run)
%input('press enter to continue')

end
xlswrite('simulationExample1.xlsx',MAE,'1','A1')
xlswrite('simulationExample1.xlsx',MSE,'1','B1')
xlswrite('simulationExample1.xlsx',coverage,'1','C1')
xlswrite('simulationExample1.xlsx',avepredintlength,'1','D1')
xlswrite('simulationExample1.xlsx',time,'1','E1')
xlswrite('simulationExample1.xlsx',MAE2,'2','A1')
xlswrite('simulationExample1.xlsx',MSE2,'2','B1')
xlswrite('simulationExample1.xlsx',coverage2,'2','C1')
xlswrite('simulationExample1.xlsx',avepredintlength2,'2','D1')
xlswrite('simulationExample1.xlsx',time2,'2','E1')

function MSE=OptimizeParameters(par)
global DesignUncoded MeshPoints tlist Data designsize N
%checked 4
eta=exp(par(1));
weights=exp(par(2:3));
Prediction=zeros(designsize,N);

for i=1:designsize
    InitialFunctionVal=u0func(MeshPoints,DesignUncoded(i,3));
    x=DesignUncoded(i,7);
    x0=[Inf];
    profile=computeprofile(DesignUncoded(i,1),DesignUncoded(i,2),DesignUncoded(i,5),DesignUncoded(i,6),MeshPoints);
    Yhat=InitialConditionAnalyticalApproxInterpolator(MeshPoints,tlist,eta,tlist,MeshPoints,InitialFunctionVal,x,x0,weights,profile);
    Prediction(i,:)=Yhat';
end

MSE=mean(mean((Data-Prediction).^2));

function [u, MeshPoints2, e, t]=computetemperature(parameters)
global b1 b2 thick hCoeff ta k r tlist
%checked 4
if(min(size(parameters))~=1)
    display('error')
    return
end
L=1;

b1=parameters(1);
b2=parameters(2);
init=parameters(3);
thick=parameters(4);
hCoeff=parameters(5);
ta=parameters(6);
k=parameters(7);
r=parameters(8);

numberOfPDE = 1;
pdem = createpde(numberOfPDE);

C1 = [1,0,0,L]';
C2 = [1,0,0,L/4]';
geom = [C1,C2];
% Names for the two geometric objects
ns = (char('C1','C2'))';
% Set formula
sf = 'C1-C2';
g = decsg(geom,sf,ns);
% Convert the DECSG geometry into a geometry object
% on doing so it is appended to the PDEModel
geometryFromEdges(pdem,g);

[MeshPoints2,e,t] = initmesh(g,'Hmax',0.2);

a2=2*hCoeff;
f2=2*(hCoeff*ta)+thick*0;
r2=r*thick;
c=k*thick;

u0=u0func(MeshPoints2',init);

u=parabolic(u0,tlist,@pdebound,MeshPoints2,e,t,c,a2,f2,r2);

%figure(10),pdegplot(pdem,'EdgeLabels','on') 
%figure(1),pdeplot(MeshPoints2,e,t) 
%figure(2),pdesurf(MeshPoints2,t,u(:,1))
%figure(3),pdesurf(MeshPoints2,t,u(:,2))
%figure(4),pdesurf(MeshPoints2,t,u(:,end))
%input('press enter')

function [qmatrix,gmatrix,hmatrix,rmatrix] = pdebound(p,e,u,time)
global b1 b2
%checked 4
ne = size(e,2); % number of edges
qmatrix = zeros(1,ne);
gmatrix = qmatrix;

hmatrix = zeros(1,2*ne);
rmatrix = hmatrix;
for k = 1:ne
    if(ismember(e(5,k),[1 2 3 4])==1)
        xm=(p(1,e(1,k))+p(1,e(2,k)))/2;
        ym=(p(2,e(1,k))+p(2,e(2,k)))/2;
        theta=atan2(ym,xm);
        gmatrix(k)=b1*(1+0.3*sin(2*theta));
    elseif(ismember(e(5,k),[5 6 7 8])==1)
        xm=(p(1,e(1,k))+p(1,e(2,k)))/2;
        ym=(p(2,e(1,k))+p(2,e(2,k)))/2;
        theta=atan2(ym,xm);        
        gmatrix(k)=b2*(1+0.3*sin(2*theta));
    end
end

function u0=u0func(MeshPoints,par)
%checked 4
np = size(MeshPoints,1); % Number of mesh points
u0 = zeros(np,1); % Allocate initial matrix
for k = 1:np
    x = MeshPoints(k,1);
    y = MeshPoints(k,2);
    u0(k) = 270-par*(x^2+y^2); % Fill in row k
end

function Profile=computeprofile(b1in,b2in,hCoeffin,tain,Mesh)
%checked 4
b1=b1in;
b2=b2in;
hCoeff=hCoeffin;
ta=tain;
nmesh=size(Mesh,1);

Profile=(ta+(b1*1+b2*0.25)/((1^2-0.25^2)*hCoeff))*ones(nmesh,1);
