function [Ypred, UCL, LCL]=FunctionalGPPredict(Din1,Din2,Yin,Noin,x,thetaopt,beta,sigma2,R1I,R2I,RIRes)
%checked 4

global D1 D2 Y F n No n1 n2 d1 d2

No=Noin;
D1=Din1;
D2=Din2;
Y=Yin;
[n1, d1]=size(D1);
[n2, d2]=size(D2);
n=n1*n2;
d=d1+d2;
F=ones(n,1);

D=[repmat(D1,n2,1) kron(D2,ones(n1,1))];
m=size(x,1);

R4=zeros(m,n);
for i=1:m
    for j=1:n
        R4(i,j)=CompCorr(x(i,:),D(j,:),thetaopt);
    end
end
Ypred=beta+R4*RIRes;
    
R5=zeros(m,1);
for i=1:m
    R5(i,1)=CompCorr(x(i,:),x(i,:),thetaopt);
end

R6=zeros(m,1);
for j=1:m  
    dummy=R1I*reshape(R4(j,:)',n1,n2)*R2I;
    RIR4T=dummy(:);
    R6(j,1)=R4(j,:)*RIR4T;
end
PosVar=sigma2*(R5-R6);
RMSE=sqrt(max(PosVar,0));
LCL=Ypred-norminv(0.99)*RMSE;
UCL=Ypred+norminv(0.99)*RMSE;

function Corr=CompCorr(x1,x2,r)
global No
if(No==0)
    Corr=prod(r.^((x1-x2).^2));
elseif(No==1)
    rho=x1-x2;
    rho1=sqrt(6)*abs(rho)./r;
    Corr=prod((exp(-rho1)).*(rho1+1));
elseif(No==2)
    rho=x1-x2;
    rho1=2*sqrt(2.5)*abs(rho)./r;
    Corr=prod((exp(-rho1)/3).*(rho1.^2+3*rho1+3)); 
end