function Prediction=InitialConditionAnalyticalApproxInterpolator(z,t,eta,tlist,MeshPoints,InitialFunctionVal,x,x0,weights,profile)
%checked 4
if(tlist(1)~=0)
    display('error')
    return
end
m1=size(z,1);
m2=length(t);
m=m1*m2;
nmesh=size(MeshPoints,1);

scaledgrid=[MeshPoints sqrt(eta)*zeros(nmesh,1); MeshPoints zeros(nmesh,1)];
Ygrid=[InitialFunctionVal; profile];
s=[repmat(z,m2,1) sqrt(eta)*kron(t,ones(m1,1))];
dist2x=sum(weights(2).*((1/x-1/x0).^2));

Prediction=zeros(m,1);
for i=1:m
    %note that s(i,3) is time multiplied by sqrt(eta)
    dist2=[pdist2(scaledgrid(1:nmesh,:),s(i,:)).^2; pdist2(scaledgrid((nmesh+1):end,:),[s(i,1:2) sqrt(weights(1))/s(i,3)]).^2+dist2x];
    Identify=dist2<10^-32;
    if(sum(Identify)==1)
        Prediction(i)=Ygrid(Identify);        
    elseif(sum(Identify)>1)
        Prediction(i)=mean(Ygrid(Identify));
    else
        Prediction(i)=sum(Ygrid./dist2)/sum(1./dist2);
    end
end
