function TissueHeatingExample
global BoundaryNodeCoordinates BoundaryNodeLabels DesignUncoded MeshPoints Data designsize nmesh
%checked 4
d=8;

%frequency,U,K1,K2,GB1cB,GB2cB,TB,Qm1,Qm2,TSU,TSD
%Min=[100 5 0.5 0.6 2100 8400 37 4200 42000 32.5 32.5]
%Max=[400 20 0.5 0.6 2100 8400 37 4200 42000 32.5 32.5]
Min=[100 5 26.4 26.4 0.4 0.48 1680 6720];
Max=[400 20 37.7 37.7 0.6 0.72 2520 10080];
Range=Max-Min;

ntest=150;
xtest=lhsdesign(ntest,d,'criterion','maximin');
xtestuncoded=xtest.*repmat(Range,ntest,1)+repmat(Min,ntest,1);

[u, MeshPoints, e, t]=TissueHeating([Max(1) Max(2) Max(5) Max(6) Max(7) Max(8) 37 4200 42000 Max(3) Max(4)]);

N=length(u(:));
MeshPoints=MeshPoints';
nmesh=size(MeshPoints,1);

ytest=zeros(ntest,N);
for i=1:ntest
    u=TissueHeating([xtestuncoded(i,1) xtestuncoded(i,2) xtestuncoded(i,5) xtestuncoded(i,6) xtestuncoded(i,7) xtestuncoded(i,8) 37 4200 42000 xtestuncoded(i,3) xtestuncoded(i,4)]);
    ytest(i,:)=u(:)';
end

nb=size(e,2);
BoundaryNodeIndices=[];
BoundaryNodeLabels=[];
for i=1:nb
if(ismember(e(5,i),[3 4 5 14 15 16])==1)
    BoundaryNodeIndices=[BoundaryNodeIndices, e(1:2,i)];
    BoundaryNodeLabels=[BoundaryNodeLabels, e(5,i)];
end
end
BoundaryNodeIndices=BoundaryNodeIndices(:);
[BoundaryNodeIndices,uI]=unique(BoundaryNodeIndices);
BoundaryNodeCoordinates=MeshPoints(BoundaryNodeIndices,:);
BoundaryNodeLabels=[kron(BoundaryNodeLabels,ones(1,2))]';
BoundaryNodeLabels=BoundaryNodeLabels(uI);
grid=MeshPoints;

CorrelNo=1;
designsize=7*d;
nosim=1;

MSE=zeros(nosim,1);
MAE=zeros(nosim,1);
coverage=zeros(nosim,1);
avepredintlength=zeros(nosim,1);
time=zeros(nosim,1);

MSE2=zeros(nosim,1);
MAE2=zeros(nosim,1);
coverage2=zeros(nosim,1);
avepredintlength2=zeros(nosim,1);
time2=zeros(nosim,1);

MSE3=zeros(nosim,1);
MAE3=zeros(nosim,1);
coverage3=zeros(nosim,1);
avepredintlength3=zeros(nosim,1);
time3=zeros(nosim,1);

for run=1:nosim
Design=lhsdesign(designsize,d,'criterion','maximin');
DesignUncoded=Design.*repmat(Range,designsize,1)+repmat(Min,designsize,1);

Data=zeros(designsize,N);
for i=1:designsize
    [solution]=TissueHeating([DesignUncoded(i,1) DesignUncoded(i,2) DesignUncoded(i,5) DesignUncoded(i,6) DesignUncoded(i,7) DesignUncoded(i,8) 37 4200 42000 DesignUncoded(i,3) DesignUncoded(i,4)]);
    Data(i,:)=solution(:)';
end

tic
[thetaopt,beta,sigma2,R1I,R2I,RIRes]=FunctionalGPFit(Design,grid,Data(:),CorrelNo);
Ypred2=zeros(ntest,N);
UCL2=zeros(ntest,N); 
LCL2=zeros(ntest,N);
for i=1:ntest
[Ypred2(i,:), UCL2(i,:), LCL2(i,:)]=FunctionalGPPredict(Design,grid,Data(:),CorrelNo,[repmat(xtest(i,:),N,1) grid],thetaopt,beta,sigma2,R1I,R2I,RIRes);
end
toc
AbsErr2=abs(Ypred2-ytest);
MAE2(run)=mean(mean(AbsErr2));
MSE2(run)=mean(mean(AbsErr2.^2));
coverage2(run)=mean(mean((LCL2<=ytest).*(ytest<=UCL2)));
avepredintlength2(run)=mean(mean(UCL2-LCL2));
time2(run)=toc;

tic

Q=zeros(designsize,N);
for i=1:designsize
    BoundaryNodeValues=computeBoundaryNodeValuesTissueHeating(DesignUncoded(i,:),BoundaryNodeCoordinates,BoundaryNodeLabels);
    Yhat=BoundaryInterpolatorTissueHeating(MeshPoints,BoundaryNodeCoordinates,BoundaryNodeValues);
    Q(i,:)=Yhat';
end

transformeddata=Data-Q;

[EigVec,EigVal,zeta,MY]=functionalPCA(transformeddata);

J=find((cumsum(EigVal)/sum(EigVal))>0.999,1,'first');
EL=EigVec(:,1:J)*diag(sqrt(EigVal(1:J)));

zetapred=zeros(J,ntest);
zetaPosCov=cell(1,J);
for i=1:J
    [zetapred(i,:),zetaPosCov{i}]=GPFitPredict(Design,zeta(:,i),CorrelNo,xtest,2);
end
posmean=EL*zetapred;

poscov=cell(1,ntest);
for i=1:ntest
    C=zeros(J,J);
    for j=1:J
        C(j,j)=zetaPosCov{j}(i,i);
    end
    poscov{i}=EL*C*EL';
end
PredictTest=posmean;

BItest=zeros(N,ntest);
for i=1:ntest
    BoundaryNodeValues=computeBoundaryNodeValuesTissueHeating(xtestuncoded(i,:),BoundaryNodeCoordinates,BoundaryNodeLabels);
    BItest(:,i)=BoundaryInterpolatorTissueHeating(MeshPoints,BoundaryNodeCoordinates,BoundaryNodeValues);
end
PredictTest=PredictTest+BItest+repmat(MY,1,ntest);

UCL=zeros(N,ntest);
LCL=zeros(N,ntest);
for i=1:ntest
    UCL(:,i)=PredictTest(:,i)+norminv(0.99)*sqrt(diag(poscov{i}));
    LCL(:,i)=PredictTest(:,i)-norminv(0.99)*sqrt(diag(poscov{i}));    
end
toc

AbsErr=abs(PredictTest'-ytest);
MAE(run)=mean(mean(AbsErr));
MSE(run)=mean(mean(AbsErr.^2));
NumerErrorBuffer=zeros(ntest,N);
NumerErrorBuffer(:,BoundaryNodeIndices)=10^-5;
coverage(run)=mean(mean(((LCL'-NumerErrorBuffer)<=ytest).*(ytest<=(UCL'+NumerErrorBuffer))));
avepredintlength(run)=mean(mean(UCL-LCL));
time(run)=toc;






tic

[EigVec,EigVal,zeta,MY]=functionalPCA(Data);

J=find((cumsum(EigVal)/sum(EigVal))>0.999,1,'first');
EL=EigVec(:,1:J)*diag(sqrt(EigVal(1:J)));

zetapred=zeros(J,ntest);
zetaPosCov=cell(1,J);
for i=1:J
    [zetapred(i,:),zetaPosCov{i}]=GPFitPredict(Design,zeta(:,i),CorrelNo,xtest,2);
end
posmean=EL*zetapred;

poscov=cell(1,ntest);
for i=1:ntest
    C=zeros(J,J);
    for j=1:J
        C(j,j)=zetaPosCov{j}(i,i);
    end
    poscov{i}=EL*C*EL';
end
PredictTest=posmean+repmat(MY,1,ntest);

UCL=zeros(N,ntest);
LCL=zeros(N,ntest);
for i=1:ntest
    UCL(:,i)=PredictTest(:,i)+norminv(0.99)*sqrt(diag(poscov{i}));
    LCL(:,i)=PredictTest(:,i)-norminv(0.99)*sqrt(diag(poscov{i}));    
end
toc

AbsErr=abs(PredictTest'-ytest);
MAE3(run)=mean(mean(AbsErr));
MSE3(run)=mean(mean(AbsErr.^2));
coverage3(run)=mean(mean((LCL'<=ytest).*(ytest<=UCL')));
avepredintlength3(run)=mean(mean(UCL-LCL));
time3(run)=toc;

end

xlswrite('TissueHeating.xlsx',MAE,'1','A1')
xlswrite('TissueHeating.xlsx',MSE,'1','B1')
xlswrite('TissueHeating.xlsx',coverage,'1','C1')
xlswrite('TissueHeating.xlsx',avepredintlength,'1','D1')
xlswrite('TissueHeating.xlsx',time,'1','E1')
xlswrite('TissueHeating.xlsx',MAE2,'2','A1')
xlswrite('TissueHeating.xlsx',MSE2,'2','B1')
xlswrite('TissueHeating.xlsx',coverage2,'2','C1')
xlswrite('TissueHeating.xlsx',avepredintlength2,'2','D1')
xlswrite('TissueHeating.xlsx',time2,'2','E1')
xlswrite('TissueHeating.xlsx',MAE3,'3','A1')
xlswrite('TissueHeating.xlsx',MSE3,'3','B1')
xlswrite('TissueHeating.xlsx',coverage3,'3','C1')
xlswrite('TissueHeating.xlsx',avepredintlength3,'3','D1')
xlswrite('TissueHeating.xlsx',time3,'3','E1')

function [u, MeshPoints, e, t]=TissueHeating(parameters)
global epsilon1 epsilon2 U sigmac1 sigmac2 K1 K2 GB1cB GB2cB TB Qm1 Qm2 TSU TSD phi
%checked 4
if(min(size(parameters))~=1)
    display('error')
    return
end 
%frequency,U,K1,K2,GB1cB,GB2cB,TB,Qm1,Qm2,TSU,TSD
%Min=[1*10^9 5 0.5 0.6 2100 8400 37 4200 42000 32.5 32.5]
%Max=[20*10^9 20 0.5 0.6 2100 8400 37 4200 42000 32.5 32.5]
frequency=parameters(1);
[epsilon1,epsilon2,sigmac1,sigmac2]=ColeColeModels(frequency);
U=parameters(2);
K1=parameters(3);
K2=parameters(4);
GB1cB=parameters(5);
GB2cB=parameters(6);
TB=parameters(7);
Qm1=parameters(8);
Qm2=parameters(9);
TSU=parameters(10);
TSD=parameters(11);

numberOfPDE = 1;
pdem = createpde(numberOfPDE);

R1 = [3,4,0,0,0.08,0.08,0.04,0,0,0.04]';
R2 = [3,4,0.032,0.032,0.048,0.048,0.032,0.016,0.016,0.032]';
R3 = [3,4,0.032,0.032,0.048,0.048,0.016,0,0,0.016]';
R4 = [3,4,0.032,0.032,0.048,0.048,0.04,0.032,0.032,0.04]';
geom = [R1,R2,R3,R4];
% Names for the two geometric objects
ns = (char('R1','R2','R3','R4'))';
% Set formula
sf = 'R1+R2+R3+R4';
g = decsg(geom,sf,ns);
% Convert the DECSG geometry into a geometry object
% on doing so it is appended to the PDEModel
geometryFromEdges(pdem,g);

% Create the triangular mesh on the square with approximately
% ten elements in each direction.
[MeshPoints,e,t] = initmesh(g,'Hmax',0.005);

%figure(1),pdeplot(MeshPoints,e,t)
%figure(2),pdegplot(pdem,'EdgeLabels','on') 

phi=assempde(@pdeboundE,MeshPoints,e,t,@cfuncE,0,0);

u=assempde(@pdeboundH,MeshPoints,e,t,@cfuncH,@afunc,@ffunc);

%figure(3),pdesurf(MeshPoints,t,u)
%[max(u) min(u)]
%sigmac1,sigmac2
%input('press enter')

function [qmatrix,gmatrix,hmatrix,rmatrix] = pdeboundE(p,e,u,time)
global U 
%checked 4
ne = size(e,2); % number of edges
qmatrix = zeros(1,ne);
gmatrix = qmatrix;

hmatrix = zeros(1,2*ne);
rmatrix = zeros(1,2*ne);
for k = 1:ne
%    x1=p(1,e(1,k));
%    x2=p(1,e(2,k));
%    y1=p(2,e(1,k));
%    y2=p(2,e(2,k));
    if(ismember(e(5,k),[15])==1)
        hmatrix(k)=1;
        hmatrix(k+ne)=1;        
        rmatrix(k)=U;
        rmatrix(k+ne)=U;
    elseif(ismember(e(5,k),[4])==1)
        hmatrix(k)=1;
        hmatrix(k+ne)=1;         
        rmatrix(k)=-U;
        rmatrix(k+ne)=-U;
    else
        gmatrix(k) = 0;  
    end
end

function [qmatrix,gmatrix,hmatrix,rmatrix] = pdeboundH(p,e,u,time)
global TSU TSD
%checked 4
ne = size(e,2); % number of edges
qmatrix = zeros(1,ne);
gmatrix = qmatrix;

hmatrix = zeros(1,2*ne);
rmatrix = zeros(1,2*ne);
for k = 1:ne
%    x1=p(1,e(1,k));
%    x2=p(1,e(2,k));
%    y1=p(2,e(1,k));
%    y2=p(2,e(2,k));
    if(ismember(e(5,k),[3 4 5])==1)
        hmatrix(k)=1;
        hmatrix(k+ne)=1;        
        rmatrix(k)=TSD;
        rmatrix(k+ne)=TSD;
    elseif(ismember(e(5,k),[14 15 16])==1)
        hmatrix(k)=1;
        hmatrix(k+ne)=1;         
        rmatrix(k)=TSU;
        rmatrix(k+ne)=TSU;
    else
        gmatrix(k) = 0;  
    end
end

function cE = cfuncE(p,t,u,time)
global epsilon1 epsilon2 
%checked 4
nt=size(t,2);
cE=zeros(1,nt);

it1 = t(1,:);
it2 = t(2,:);
it3 = t(3,:);
xpts = (p(1,it1)+p(1,it2)+p(1,it3))/3;
ypts = (p(2,it1)+p(2,it2)+p(2,it3))/3;

for i=1:nt
    if((xpts(i)>=0.032)&&(xpts(i)<=0.048)&&(ypts(i)>=0.016)&&(ypts(i)<=0.032))
        cE(i)=epsilon2*8.85*10^-12;
    else  
        cE(i)=epsilon1*8.85*10^-12;
    end
end

function cH = cfuncH(p,t,u,time)
global K1 K2 
%checked 4
nt=size(t,2);
cH=zeros(1,nt);

it1 = t(1,:);
it2 = t(2,:);
it3 = t(3,:);
xpts = (p(1,it1)+p(1,it2)+p(1,it3))/3;
ypts = (p(2,it1)+p(2,it2)+p(2,it3))/3;

for i=1:nt
    if((xpts(i)>=0.032)&&(xpts(i)<=0.048)&&(ypts(i)>=0.016)&&(ypts(i)<=0.032))
        cH(i)=K2;
    else  
        cH(i)=K1;
    end
end

function a = afunc(p,t,u,time)
global GB1cB GB2cB 
%checked 4
nt=size(t,2);
a=zeros(1,nt);

it1 = t(1,:);
it2 = t(2,:);
it3 = t(3,:);
xpts = (p(1,it1)+p(1,it2)+p(1,it3))/3;
ypts = (p(2,it1)+p(2,it2)+p(2,it3))/3;

for i=1:nt
    if((xpts(i)>=0.032)&&(xpts(i)<=0.048)&&(ypts(i)>=0.016)&&(ypts(i)<=0.032))
        a(i)=GB2cB;
    else  
        a(i)=GB1cB;
    end
end

function f = ffunc(p,t,u,time)
global sigmac1 sigmac2 GB1cB GB2cB TB Qm1 Qm2 phi
%checked 4
nt=size(t,2);
f=zeros(1,nt);

it1 = t(1,:);
it2 = t(2,:);
it3 = t(3,:);
xpts = (p(1,it1)+p(1,it2)+p(1,it3))/3;
ypts = (p(2,it1)+p(2,it2)+p(2,it3))/3;

[phix,phiy] = pdegrad(p,t,phi);

for i=1:nt
    if((xpts(i)>=0.032)&&(xpts(i)<=0.048)&&(ypts(i)>=0.016)&&(ypts(i)<=0.032))
        f(i)=(sigmac2/2)*(phix(i)^2+phiy(i)^2)+Qm2+GB2cB*TB;
    else  
        f(i)=(sigmac1/2)*(phix(i)^2+phiy(i)^2)+Qm1+GB1cB*TB;
    end
end

function [epsilon1,epsilon2,sigmac1,sigmac2]=ColeColeModels(frequency)
%checked 4
colecole1=1/(3.31+(37.26-3.31)/(1+(i*(frequency/9.358))^(0.634)));
epsilon1=imag(colecole1)/(8.85*10^-12*frequency*1000*2*pi);
sigmac1=real(colecole1);

colecole2=1/(1.94+(6.23-1.94)/(1+(i*(frequency/144.731))^(0.503)));
epsilon2=imag(colecole2)/(8.85*10^-12*frequency*1000*2*pi);
sigmac2=real(colecole2);

function BoundaryNodeVals=computeBoundaryNodeValuesTissueHeating(x,BoundaryNodeCoordinates,BoundaryNodeLabels)
%checked 4
nb=length(BoundaryNodeLabels);
BoundaryNodeVals=zeros(nb,1);
for i=1:nb
    if(ismember(BoundaryNodeLabels(i),[3 4 5]))        
        BoundaryNodeVals(i)=x(4);
    elseif(ismember(BoundaryNodeLabels(i),[14 15 16]))  
        BoundaryNodeVals(i)=x(3);        
    end
end